#
# Author: Bill ye <ting.ye@asianux.com>
#

from yum.plugins import PluginYumExit, TYPE_CORE
requires_api_version = '2.3'
plugin_type = (TYPE_CORE,)

import os
import re
import sys
import string
from yum import yumRepo
import urllib

sys.path.append("/usr/share/rhn/up2date_client/")
import axtuPost
import config

class chnnl:
   def __init__(self):
     self.label = None
     self.name = None
     self.baseurl = None
     self.gpgcheck = None
     self.basecachedir = None

class accanal:
  def __init__(self, obj=None):
    self.obj = obj
    self.chnnls = []
    self.errmsg = None

  def getpart(self, aki):
    flag = 0
    line = None
    while 1:
      line = self.obj.readline()
      if line:
        if len(line) == 1:
          continue
        a = string.split(line)
        b = len(a)
        if b == 1:
          if a[0] == "[base]" or a[0] == "[updates-released]":
            pass
          else:
            continue
        if b == 0 or b == 2:
          continue
        if a[0] == "Result" and a[2] != "1":
          ret = string.atoi(a[2])
          if ret == -1:
            errmsg = "User name and password do not match"
          elif ret == -2:
            errmsg = "Product number is not correct"
          elif ret == -3:
            errmsg = "Product type is not correct"
          elif ret == -4:
            errmsg = "authKey is not correct"
          elif ret == -5:
            errmsg = "Authentication database cannot be connect"
          elif ret == -6:
            errmsg = "Hash_value is redundancy"
          elif ret == -7:
            errmsg = "The number of licence is full"
          elif ret == -8:
            errmsg = "The system name is redundancy"
          elif ret == -9:
            errmsg = "The authentication period is expired"
          elif ret == -10:
            errmsg = "The arguments is not enough"
          elif ret == -11:
            errmsg = "The repository url cannot be got"
          else:
            errmsg = "Authentication failed"
          self.errmsg = errmsg
          return False
        if a[0] == "TempKey":
          self.tk = a[2]
        if a[0] == "[base]":
          chn = chnnl()
          chn.label = "axs4_base"
          flag = 1
        if a[0] == "name" and flag == 1:
          self.basename = a[2]+' '+a[3]+' '+a[4]
          chn.name = self.basename
        if a[0] == "baseurl" and flag == 1:
          self.baseurl = a[2]
          self.ak = aki 
          url = self.baseurl[0:7] + self.ak + ":" + self.tk + "@" + self.baseurl[7:-1]
          chn.baseurl = url
          self.chnnls.append(chn)
          flag = 2
        if a[0]  == "[updates-released]":
          chn = chnnl()
          chn.label = "axs4_update"
          flag = 3
        if a[0] == "name" and flag == 3:
          self.updatename = a[2]+' '+a[3]+' '+a[4]
          chn.name = self.updatename
        if a[0] == "baseurl" and flag == 3:
          self.updatebaseurl = a[2]
          url = self.updatebaseurl[0:7] + self.ak + ":" + self.tk + "@" + self.updatebaseurl[7:-1]
          chn.baseurl = url
          self.chnnls.append(chn)
      else:
	break

    return True 

def gpgkeyloc():
  path = "file:///usr/share/doc/asianux-release/"
  path1 = "/usr/share/doc/asianux-release/"
  a = []
  for i in os.listdir(path1):
    r = re.match('RPM-GPG-KEY', i)
    if r is not None:
      a.append(path + i)
  return a

def get_proxy_url(up2date_cfg):
    if not up2date_cfg['enableProxy']:
        return None

    proxy_url = "http://"
    if up2date_cfg['enableProxyAuth']:
        if not up2date_cfg.has_key('proxyUser') or \
            up2date_cfg['proxyUser'] == '':
            return "BadProxyConfig"
        if not up2date_cfg.has_key('proxyPassword') or \
            up2date_cfg['proxyPassword'] == '':
            return "BadProxyConfig"
        proxy_url = proxy_url + up2date_cfg['proxyUser']
        proxy_url = proxy_url + ':'
        proxy_url = proxy_url + urllib.quote(up2date_cfg['proxyPassword'])
        proxy_url = proxy_url + '@'

    netloc = up2date_cfg['httpProxy']
    if netloc == '':
        return "BadProxyConfig"

    # Check if a protocol is supplied. We'll ignore it.
    proto_split = netloc.split('://')
    if len(proto_split) > 1:
       netloc = proto_split[1]

    return proxy_url + netloc

def get_proxies(proxy_url):
    if proxy_url == None:
      proxies = {}
    else:
      proxies = {'http':proxy_url}
    return proxies


def accessprocess(conduit):
    cfg = config.initUp2dateConfig()
    ak = cfg['authKey']
    poststr=axtuPost.poststr2(ak)
    urlstr = cfg['serverURL']
    proxy_url = get_proxy_url(cfg)
    if "BadProxyConfig" == proxy_url:
      print "There was an error parsing the TSN proxy settings. "
      print "axtu-plugin disabled"
      return
    proxies = get_proxies(proxy_url)
    try:
      opener = urllib.FancyURLopener(proxies)
      rst = opener.open(urlstr, poststr)
    except IOError, e:
      print "IOError occur, axtu-plugin disabled"
      print e
      return
    tmprst = accanal(rst)
    if tmprst.getpart(ak):
      repos = conduit.getRepos()
      cachedir = conduit.getConf().cachedir
      default_gpgcheck = conduit.getConf().gpgcheck
      gpgcheck = conduit.confBool('main', 'gpgcheck', default_gpgcheck)
      enablegroups = conduit.getConf().enablegroups
      gpgkey = gpgkeyloc()
      for channel in tmprst.chnnls:
        repo = yumRepo.YumRepository(channel.label)
        repo.name = channel.name
        repo.baseurl = channel.baseurl
        repo.gpgcheck = gpgcheck
        repo.basecachedir = cachedir
        repo.gpgkey = gpgkey
	repo.proxy = proxy_url
        repo.enablegroups = enablegroups
        repo.enable()
        repos.add(repo)
    else:
      print tmprst.errmsg
      print "axtu-plugin disabled"

def init_hook(conduit):
    cfg = config.initUp2dateConfig()
    if len(cfg['authKey']) < 32:
      print "Please register, or you can not connect to Asianux Update Server!"
    else:
      accessprocess(conduit)

